var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { JsonConverter, JsonElementType, JsonObject, JsonProperty } from 'ta-json-x';
import { Metadata } from '../../models/metadata';
import { Properties } from '../../models/properties';
import { JsonStringConverter } from '../../models/converters/string-converter';
import { MediaOverlay } from './metadata/media-overlay';
let EPUBMetadata = class EPUBMetadata extends Metadata {
};
__decorate([
    JsonProperty('rendition'),
    __metadata("design:type", Properties)
], EPUBMetadata.prototype, "rendition", void 0);
__decorate([
    JsonProperty('source'),
    __metadata("design:type", String)
], EPUBMetadata.prototype, "source", void 0);
__decorate([
    JsonConverter(JsonStringConverter),
    JsonProperty('epub-type'),
    JsonElementType(String),
    __metadata("design:type", Array)
], EPUBMetadata.prototype, "epubType", void 0);
__decorate([
    JsonProperty('rights'),
    __metadata("design:type", String)
], EPUBMetadata.prototype, "rights", void 0);
__decorate([
    JsonProperty('media-overlay'),
    __metadata("design:type", MediaOverlay)
], EPUBMetadata.prototype, "mediaOverlay", void 0);
EPUBMetadata = __decorate([
    JsonObject()
], EPUBMetadata);
export { EPUBMetadata };
//# sourceMappingURL=metadata.js.map