var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var EPUBPublication_1;
import { JSON as TaJson, JsonElementType, JsonObject, JsonProperty } from 'ta-json-x';
import { Link } from '../../models/link';
import { Publication } from '../../models/publication';
import { EPUBMetadata } from './metadata';
let EPUBPublication = EPUBPublication_1 = class EPUBPublication extends Publication {
    static parse(json) {
        return TaJson.parse(json, EPUBPublication_1);
    }
};
__decorate([
    JsonProperty('metadata'),
    __metadata("design:type", EPUBMetadata)
], EPUBPublication.prototype, "metadata", void 0);
__decorate([
    JsonProperty('toc'),
    JsonElementType(Link),
    __metadata("design:type", Array)
], EPUBPublication.prototype, "toc", void 0);
__decorate([
    JsonProperty('page-list'),
    JsonElementType(Link),
    __metadata("design:type", Array)
], EPUBPublication.prototype, "pageList", void 0);
__decorate([
    JsonProperty('landmarks'),
    JsonElementType(Link),
    __metadata("design:type", Array)
], EPUBPublication.prototype, "landmarks", void 0);
__decorate([
    JsonProperty('loi'),
    JsonElementType(Link),
    __metadata("design:type", Array)
], EPUBPublication.prototype, "loi", void 0);
__decorate([
    JsonProperty('loa'),
    JsonElementType(Link),
    __metadata("design:type", Array)
], EPUBPublication.prototype, "loa", void 0);
__decorate([
    JsonProperty('lov'),
    JsonElementType(Link),
    __metadata("design:type", Array)
], EPUBPublication.prototype, "lov", void 0);
__decorate([
    JsonProperty('lot'),
    JsonElementType(Link),
    __metadata("design:type", Array)
], EPUBPublication.prototype, "lot", void 0);
EPUBPublication = EPUBPublication_1 = __decorate([
    JsonObject()
], EPUBPublication);
export { EPUBPublication };
//# sourceMappingURL=publication.js.map