import { Link } from '../../models/link';
import { Publication } from '../../models/publication';
import { EPUBMetadata } from './metadata';
export declare class EPUBPublication extends Publication {
    metadata: EPUBMetadata;
    toc: Link[];
    pageList: Link[];
    landmarks: Link[];
    loi: Link[];
    loa: Link[];
    lov: Link[];
    lot: Link[];
    static parse(json: string): EPUBPublication;
}
